//****************************************************************
//* Ce fichier et le fichier lib.h contienentles structures et   * 
//* les fonctions  que vous serez amener à utiliser. Vous n'avez * 
//* normalement pas besoin de modifier ces fichiers.             *
//**************************************************************** 

#include "lib.h"

void sdl_init(){
  SDL_Init(SDL_INIT_VIDEO);
}

usint arrondi(float f){
  return (usint)(f+0.5);
}

Point::Point(){
  x=0;
  y=0;
}

Point::Point(float xx,float yy){
  x=xx;
  y=yy;
}

Carre::Carre(){
}

Carre::Carre(Point CC,usint ll){
  CC=C;
  ll=l;
}

ostream& operator<<(ostream& os,const Point& P){
  os<<"("<<P.x<<","<<P.y<<")";
  return os;
}

Couleur::Couleur(unsigned char r,unsigned char g,unsigned char b){
  red=r;green=g;blue=b;
}

Couleur::Couleur(unsigned char g){
  red=g;green=g;blue=g;
}

Ecran_SDL::Ecran_SDL(int w,int h){
  sdl_screen=SDL_SetVideoMode(w, h, 32, SDL_HWSURFACE | SDL_DOUBLEBUF);
  rafraichir();
}

void Ecran_SDL::rafraichir(){
  SDL_Flip(sdl_screen);
}

void Ecran_SDL::dessine_point(Point P,Couleur c){
  if(P.x>=sdl_screen->w or P.y>=sdl_screen->h) return;
  *((Uint32*)(sdl_screen->pixels) +  arrondi(P.x) + arrondi(P.y) * sdl_screen->w) =SDL_MapRGB(sdl_screen->format, c.red, c.green, c.blue);
}

void Ecran_SDL::effacer(){
  SDL_FillRect(sdl_screen,NULL,SDL_MapRGB(sdl_screen->format,0,0,0));
}

Evenement attendre_evenement(){
  Evenement e;
  SDL_WaitEvent(&e);
  return e;
}

bool est_quitter(Evenement& e){
  return e.type==SDL_QUIT;
}

bool est_bouton_souris_enfoncer(Evenement& e){
  return e.type==SDL_MOUSEBUTTONDOWN;
}

bool est_bouton_souris_relacher(Evenement& e){
  return e.type==SDL_MOUSEBUTTONUP;
}

bool est_deplacement_souris(Evenement& e){
  return e.type==SDL_MOUSEMOTION;
}

Point lire_position_action_bouton(Evenement& e){
  return Point(e.button.x,e.button.y);
}


Point lire_position_souris(Evenement& e){
  return Point(e.motion.x,e.motion.y);
}

void deplace_souris(Point P){
  SDL_WarpMouse(P.x,P.y);
}
