//****************************************************************
//* Ce fichier et le fichier lib.cpp contienentles structures et * 
//* les fonctions  que vous serez amener à utiliser. Vous n'avez * 
//* normalement pas besoin de modifier ces fichiers.             *
//**************************************************************** 

#ifndef LIBRAIRIE_H
#define LIBRAIRIE_H

#include <iostream>
#include <stdlib.h>
#include <stdio.h>
#include <SDL/SDL.h>


using namespace std;

typedef unsigned short int usint;

//************ SDL *************//

void sdl_init();

//********** DESSIN ***********//

usint arrondi(float f);

class Point{
 public:
  float x,y;
  Point();
  Point(float,float);
  friend ostream& operator<<(ostream& os,const Point& P);
};

class Couleur{
 public:
  unsigned char red,green,blue;
  Couleur(unsigned char r,unsigned char g,unsigned char b);
  Couleur(unsigned char g);
};

class Carre{
public:
  Point C;
  usint l;
  Carre();
  Carre(Point,usint);
};

class Ecran_SDL{
 private:
  SDL_Surface *sdl_screen;
 public:
  Ecran_SDL();
  Ecran_SDL(int w,int h);
  void effacer();
  void rafraichir();
  void dessine_point(Point P,Couleur c);
};




//********* EVENEMENTS ***********//

typedef SDL_Event Evenement;

Evenement attendre_evenement();
bool est_quitter(Evenement& e);
bool est_bouton_souris_enfoncer(Evenement& e);
bool est_bouton_souris_relacher(Evenement& e);
bool est_deplacement_souris(Evenement& e);
Point lire_position_action_bouton(Evenement& e);
Point lire_position_souris(Evenement& e);
void deplace_souris(Point P);
#endif
