#include "bezier.h"

  
void dessine_segment_horizontal(Ecran_SDL ecran,Point A,usint l,Couleur c){
  for(usint x=A.x;x<=A.x+l;x++){
    ecran.dessine_point(Point(x,A.y),c);
  }
}

void dessine_segment_vertical(Ecran_SDL ecran,Point A,usint l,Couleur c){
  for(usint y=A.y;y<=A.y+l;y++){
    ecran.dessine_point(Point(A.x,y),c);
  }
}

void dessine_carre(Ecran_SDL ecran,Carre carre,Couleur c){
  float d,x,y;
  x=carre.C.x;
  y=carre.C.y;
  usint l=carre.l;
  d=carre.l/2;
  dessine_segment_horizontal(ecran,Point(x-d,y+d),l,c);
  dessine_segment_horizontal(ecran,Point(x-d,y-d),l,c);
  dessine_segment_vertical(ecran,Point(x+d,y-d),l,c);
  dessine_segment_vertical(ecran,Point(x-d,y-d),carre.l,c);
}

bool est_dans_carre(Point P,Carre c){
  float d,x,y;
  x=c.C.x;
  y=c.C.y;
  d=c.l/2;
 
  return P.x>=x-d and P.x<=x+d and P.y<=y+d and P.y>=y-d;
}

int main(int argc,char* argv[]){ 

  //Initiation de SDL
  sdl_init();

  //Creation d'un ecran de taille 640x480
  Ecran_SDL ecran(640,480);

  //Gestion evenements souris + quitter
  bool continuer=true;
  bool dessiner_lors_deplacement=false;
  usint indice_carre;
  Point P;
  Evenement e;
  Couleur blanc(255);//blanc
  Couleur rouge(255,0,0);//rouge
  
  //Courbe de Bezier
  usint l=8;
  Carre* carres=new Carre[4];
  carres[0].l=carres[1].l=carres[2].l=carres[3].l=l;
  carres[0].C=Point(100,100);
  carres[1].C=Point(200,400);
  carres[2].C=Point(500,400);
  carres[3].C=Point(600,100);
  CourbeBezier courbe(carres[0].C,carres[1].C,carres[2].C,carres[3].C);  
  dessine_courbe_bezier(ecran,courbe,blanc);
  for(usint i=0;i<=3;i++){
    dessine_carre(ecran,carres[i],rouge);
  }
  ecran.rafraichir();
 
 while(continuer){
    e=attendre_evenement();
    if(est_quitter(e)){
      continuer=false;
    }
    else if(est_bouton_souris_enfoncer(e)){
      P=lire_position_action_bouton(e);
      for(usint i=0;i<=3;i++){
	if(est_dans_carre(P,carres[i])){
	  deplace_souris(carres[i].C);
	  dessiner_lors_deplacement=true;
	  indice_carre=i;
	  break;
	}
      }
    }
    else if(est_bouton_souris_relacher(e)){
      dessiner_lors_deplacement=false;
    }
    else if(est_deplacement_souris(e)){
      if(dessiner_lors_deplacement){
	P=lire_position_souris(e);
	carres[indice_carre].C=P;
	ecran.effacer();
	CourbeBezier courbe(carres[0].C,carres[1].C,carres[2].C,carres[3].C);  
	dessine_courbe_bezier(ecran,courbe,blanc);
	for(usint i=0;i<=3;i++){
	  dessine_carre(ecran,carres[i],rouge);
	}
	ecran.rafraichir();
      }
    }
  }

 
  return EXIT_SUCCESS;
}
